<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.helper');
class plgJshoppingProductsprice_round_to_05 extends JPlugin {
	  
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
        $this->loadLanguage();       
	}
	
	public function onJshopProductGetAttributesDatasAfter($obj,$vars){
		foreach($vars['data']['attributeValues'] as $ka=>$va){
			foreach($va as $kv=>$vv){
				$va[$kv]->addprice = $this->roundTo05Price($va[$kv]->addprice);
			}
		}
	}
	
	private function roundTo05Price($value){
	   $value = round($value, 2);
	   $value_temp = round(10*(10 * $value - floor(10 * $value)));
	   if ($value_temp <3){
	   	 $rest = 0;
	   } else if ($value_temp <8){
	  	 $rest = 0.05;
	   } else {
	  	 $rest = 0.1;
	   }
	 return floor(10*$value) / 10 + $rest;   
 	}
 	
 	public function onListProductUpdateData(&$products){
 		foreach($products as $k=>$v){
 			$products[$k]->product_price = $this->roundTo05Price($products[$k]->product_price);
 			$products[$k]->product_old_price = $this->roundTo05Price($products[$k]->product_old_price);
 			$products[$k]->_original_product_price = (string)$this->roundTo05Price((float)$products[$k]->_original_product_price);
 			$products[$k]->product_price_wp = $this->roundTo05Price($products[$k]->product_price_wp);
 			if(count($products[$k]->basic_price_info))$products[$k]->basic_price_info["basic_price"] = $this->roundTo05Price($products[$k]->basic_price_info["basic_price"]);
 		}	
 	}
 	
 	public function onCalculatePriceProduct($quantity, $enableCurrency, $enableUserDiscount, $enableParamsTax, &$product, &$cartProduct){
 		$product->product_old_price = (string)$this->roundTo05Price((float)$product->product_old_price);
 		$product->product_buy_price = (string)$this->roundTo05Price((float)$product->product_buy_price);
 		$product->product_price = (string)$this->roundTo05Price((float)$product->product_price);
 		$product->product_price_wp = $this->roundTo05Price($product->product_price_wp);
 		$product->product_price_calculate = $this->roundTo05Price($product->product_price_calculate);
 		$product->product_price_calculate1 = $this->roundTo05Price($product->product_price_calculate1);
 		if(count($product->product_add_prices)){
 			foreach($product->product_add_prices as $k=>$v){
 				$product->product_add_prices[$k]->price = $this->roundTo05Price($product->product_add_prices[$k]->price);
 				$product->product_add_prices[$k]->price_wp = $this->roundTo05Price($product->product_add_prices[$k]->price_wp);
 			}
 		}
 	}

 	public function updateOtherPricesIncludeAllFactors(&$product){
 		if(count($product->product_add_prices)){
 			foreach($product->product_add_prices as $k=>$v){
 				$product->product_add_prices[$k]->price = $this->roundTo05Price($product->product_add_prices[$k]->price);
 				$product->product_add_prices[$k]->price_wp = $this->roundTo05Price($product->product_add_prices[$k]->price_wp);
 			}
 		}
 	}

}
?>